#line 1 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
#include "global.h"
#include "stralloc.h"
#include "global.h"
RCSID("$Id: unicode_module.cmod,v 1.2 2001/06/28 19:18:14 per Exp $");
#include "pike_macros.h"
#include "interpret.h"
#include "program.h"
#include "program_id.h"
#include "object.h"
#include "operators.h"
#include "module_support.h"
#include "array.h"

#include "config.h"
#include "normalize.h"
#include "split.h"
#include "buffer.h"

/* must be included last */
#include "module_magic.h"

static void push_words( int *d, struct words *w )
{
  struct array *r = allocate_array( w->size );
  unsigned int i;
  
  for( i=0; i<w->size; i++ )
  {
    r->item[i].type = PIKE_T_STRING;
    r->item[i].u.string =
      make_shared_binary_string2( d+w->words[i].start,
				  w->words[i].size );
  }
  push_array( r );
  uc_words_free( w );
}


#define f_split_words_defined
void f_split_words(INT32 args) {
#line 39 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
struct pike_string * input;
#line 39 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(args != 1) wrong_number_of_args_error("split_words",args,1);
#line 39 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(Pike_sp[0-1].type != PIKE_T_STRING) SIMPLE_BAD_ARG_ERROR("split_words",1,"string");
#line 39 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
debug_malloc_pass(input=sp[0-1].u.string);
{
  struct words *res;
  struct buffer * data;
  data = uc_buffer_from_pikestring( input );
  res = unicode_split_words_buffer( data );
  pop_n_elems( args );
  push_words( data->data, res );
  uc_buffer_free( data );
}

}
#define f_split_words_and_normalize_defined
void f_split_words_and_normalize(INT32 args) {
#line 50 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
struct pike_string * input;
#line 50 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(args != 1) wrong_number_of_args_error("split_words_and_normalize",args,1);
#line 50 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(Pike_sp[0-1].type != PIKE_T_STRING) SIMPLE_BAD_ARG_ERROR("split_words_and_normalize",1,"string");
#line 50 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
debug_malloc_pass(input=sp[0-1].u.string);
{
  struct words *res;
  struct buffer *data;
  data = unicode_decompose_buffer(uc_buffer_from_pikestring(input), COMPAT_BIT);
  res = unicode_split_words_buffer( data );
  pop_n_elems( args );
  push_words( data->data, res );
  uc_buffer_free( data );
}

}
#define f_normalize_defined
void f_normalize(INT32 args) {
#line 61 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
struct pike_string * s;
#line 61 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
struct pike_string * flags;
#line 61 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(args != 2) wrong_number_of_args_error("normalize",args,2);
#line 61 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(Pike_sp[0-2].type != PIKE_T_STRING) SIMPLE_BAD_ARG_ERROR("normalize",1,"string");
#line 61 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
debug_malloc_pass(s=sp[0-2].u.string);
#line 61 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(Pike_sp[1-2].type != PIKE_T_STRING) SIMPLE_BAD_ARG_ERROR("normalize",2,"string");
#line 61 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
debug_malloc_pass(flags=sp[1-2].u.string);
#line 112 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
{
  int _flags=0, i;

  for( i = 0; i<flags->len; i++ )
    switch( flags->str[ i ] )
    {
      case 'K': _flags|=1; break;
      case 'C': _flags|=2; break;
    }

  do { struct pike_string * ret_=(unicode_normalize( s, _flags )); pop_n_elems(2); push_string(ret_); return; }while(0);
#line 123 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
}

}
#define f_is_wordchar_defined
void f_is_wordchar(INT32 args) {
#line 125 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
INT_TYPE c;
#line 125 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(args != 1) wrong_number_of_args_error("is_wordchar",args,1);
#line 125 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
if(Pike_sp[0-1].type != PIKE_T_INT) SIMPLE_BAD_ARG_ERROR("is_wordchar",1,"int");
c=Pike_sp[0-1].u.integer;
#line 126 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
{
  do { INT_TYPE ret_=(unicode_is_wordchar( c )); pop_stack(); push_int(ret_); return; }while(0);
#line 128 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
}


}
#line 131 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
void pike_module_init()
{
  
#ifdef f_split_words_defined
#line 39 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
  ADD_FUNCTION2("split_words", f_split_words, tFunc(tString,tArr(tString)), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_split_words_defined */

#ifdef f_split_words_and_normalize_defined
#line 50 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
  ADD_FUNCTION2("split_words_and_normalize", f_split_words_and_normalize, tFunc(tString,tArr(tString)), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_split_words_and_normalize_defined */

#ifdef f_normalize_defined
#line 61 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
  ADD_FUNCTION2("normalize", f_normalize, tFunc(tString tString,tString), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_normalize_defined */

#ifdef f_is_wordchar_defined
#line 125 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
  ADD_FUNCTION2("is_wordchar", f_is_wordchar, tFunc("\10\200\0\0\0\177\377\377\377","\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_is_wordchar_defined */
#line 134 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
unicode_normalize_init();
}

void pike_module_exit()
{
  
#line 140 "/usr/home/kiwi/tmp/pike-7.2.570/src/post_modules/Unicode/unicode_module.cmod"
}


